#include "testlib.h"

using namespace std;

const int NMAX = 20;
int g[NMAX][NMAX];
int color[NMAX];
int box[NMAX];

int main(int argc, char * argv[])
{
    registerTestlibCmd(argc, argv);

    int n = inf.readInt(), m = inf.readInt(), k = inf.readInt();
	memset(g, 0, sizeof g);
	for(int i = 0; i < m; ++i) {
		int x = inf.readInt(), y = inf.readInt(), z = inf.readInt();
		g[x][y] = g[y][x] = z;
	}
    memset(box, 0, sizeof box);
    for(int i = 1; i <= n; ++i) {
    	int c = ouf.readInt();
    	if (c < 1 || c > k) quitf(_wa, "box index out of range.");
    	box[c]++;
    	color[i] = c;
    }
    for(int i = 1; i <= k; ++i) if (box[i] == 0) {
    	quitf(_wa, "box number %d is empty.", i);
    }
    int jans = ans.readInt();
    int cans = 0;
    for(int i = 1; i <= n; ++i) {
	    for(int j = 1; j < i; ++j) {
	    	if (color[i] != color[j]) {
	    		cans += g[i][j];
	    	}
	    }
    }
    if (jans < cans) {
    	quitf(_wa, "jury has better answer. %d instead of %d.", jans, cans);
    }
    if (jans > cans) {
    	quitf(_fail, "contestant has better answer. %d instead of %d.", cans, jans);
    }

    quitf(_ok, "Ok, answer is %d.", jans);
}
