#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
//#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;
const int NMAX = 20;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

FILE *f = 0;
int tst = 0;

void close() {
	if (f != 0) {
	   	fclose(f);
   		f = 0;
	}
}

FILE *open() {
	close();
	char fname[10];
	sprintf(fname, "%.2d", ++tst);
	cerr << tst << endl;
	return f = fopen(fname, "wt");
}

int n, m, k;
int prob;
int g[NMAX][NMAX];

int random(int value)
{
	return ((((unsigned int)rand()) << 15) ^ ((unsigned int)rand())) % value;
}

void outdata() {
}

void solve() {
}

void fillRandom(int maxWeight = 10000000) {
	memset(g, 0, sizeof g);
	forn(i, n) {
		forn(j, i) {
			if (random(prob) == 0) continue;
			g[i][j] = g[j][i] = random(maxWeight) + 1;
		}
	}
}

int kEdge() {
	int ans = 0;
	forn(i, n) forn(j, i) if (g[i][j] != 0) {
		++ans;
	}
	return ans;
}

void printTest() {
	open();
	fprintf(f, "%d %d %d\n", n, m = kEdge(), k);
	forn(i, n) forn(j, i) if (g[i][j] != 0) {
		int x = i + 1, y = j + 1;
		if (random(2)) swap(x, y);
		fprintf(f, "%d %d %d\n", x, y, g[i][j]);
	}
}

void oneBox(int kv) {
	n = kv;
	fillRandom();
	m = kEdge();
	k = 1;
	printTest();
}

void cycle() {
	int p[3];
	p[0] = 10; p[1] = 34; p[2] = 47;
	do {
		g[0][1] = g[1][0] = p[0];
		g[2][1] = g[1][2] = p[1];
		g[2][0] = g[0][2] = p[2];
		k = 2;
		n = 3;
		m = 3;
		printTest();
	} while (next_permutation(p, p + 3));
}

void kdole(int kd, int kv) {
	memset(g, 0, sizeof g);
	n = kd * kv;
	k = kd;
	int p[NMAX];
	forn(i, n) p[i] = i;
	random_shuffle(p, p + n);
	memset(g, 0, sizeof g);
	forn(i, n) forn(j, i) {
		if (i / kv == j / kv) {
			g[p[i]][p[j]] = g[p[j]][p[i]] = random(10000000) + 1;			
		}
	}
	printTest();
}

void kdoleWithSomeEdge(int kd, int kv) {
	memset(g, 0, sizeof g);
	n = kd * kv;
	k = kd;
	int p[NMAX];
	forn(i, n) p[i] = i;
	random_shuffle(p, p + n);
	memset(g, 0, sizeof g);
	forn(i, n) forn(j, i) {
		if (i / kv == j / kv) {
			g[p[i]][p[j]] = g[p[j]][p[i]] = random(10000000) + 1;			
		} else if (random(15) == 0) {
			g[p[i]][p[j]] = g[p[j]][p[i]] = random(100000) + 1;
		}
	}
	printTest();
}

void randomTest(int kv, int ck, int maxWeight) {
	n = kv;
	k = ck;
	fillRandom(maxWeight);
	printTest();
}

void readdata() {
	open();
	fprintf(f, "3 3 2\n1 2 100\n2 3 200\n3 1 300\n");
	prob = 10;
	for(int i = 2; i <= 14; i += 4) oneBox(i);
	cycle();
	kdole(2, 2); kdole(3, 2); kdole(2, 3);
	kdole(3, 3); kdole(3, 4); kdole(4, 3);
	kdoleWithSomeEdge(3, 3);
	kdoleWithSomeEdge(3, 4);
	kdoleWithSomeEdge(4, 3);
	prob = 3;
	randomTest(10, 5, 10); randomTest(14, 5, 10);
	randomTest(10, 7, 10); randomTest(14, 7, 10);
	randomTest(10, 9, 10); randomTest(14, 9, 10);
	randomTest(13, 11, 10); randomTest(14, 11, 10);
	randomTest(13, 13, 10); randomTest(14, 14, 10);
	forn(i, 11) randomTest(14, random(13) + 2, 10000000);
	close();
}

int main() 
{
	srand(3829);
	readdata();
	solve();
	outdata();
	return 0;
}
