#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)(1e+9);

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, a) for (int i = 0; i < int(a.size()); i++)
#define fors(i, a) for (int i = 0; i < int(a.length()); i++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

#define C_IN_FILE "schema.in"
#define C_OUT_FILE "schema.out"

const int NMAX = 14;

int n, m, k;
int ans, ak, amsk;
int g[NMAX][NMAX];
int d[NMAX + 1][1 << NMAX];
int p[NMAX + 1][1 << NMAX];
int decrease[1 << NMAX];
int color[NMAX];

void outdata() {
	printf("%d\n", ans);
	memset(color, 255, sizeof color);
	while (ak > 0) {
		int inmsk = p[ak][amsk];
		assert((amsk & inmsk) == inmsk);
		forn(i, n) if (inmsk & (1 << i)) {
			assert(color[i] == -1);
			color[i] = ak;
		}
		ak--;
		amsk ^= inmsk;
	}
	forn(i, n) {
		if (i != 0) printf(" ");
		printf("%d", color[i]);
	}
	printf("\n");
}

void preCalcDecrease() {
	forn(msk, 1 << n) {
		decrease[msk] = 0;
		forn(i, n) if (msk & (1 << i)) {
			forn(j, i) if (msk & (1 << j)) {
				decrease[msk] += g[i][j];
			}
		}
	}
}

void go(int k, int msk, int inmsk, int ps) {
	if (ps == n) {
	    if (inmsk == 0) return ;
		int nans = d[k - 1][msk ^ inmsk] + decrease[inmsk];
		if (d[k][msk] < nans) {
			d[k][msk] = nans;
			p[k][msk] = inmsk;
		}
		return ;
	}
	go(k, msk << 1, inmsk << 1, ps + 1);
	go(k, (msk << 1) | 1, inmsk << 1, ps + 1);
	go(k, (msk << 1) | 1, (inmsk << 1) | 1, ps + 1);
}

void solve() {
	memset(d, 190, sizeof d);
	memset(p, 0, sizeof p);
	preCalcDecrease();
	forn(msk, 1 << n) if (msk != 0) {
		d[1][msk] = decrease[msk];
		p[1][msk] = msk;
	}
	for(int i = 2; i <= k; ++i) {
		go(i, 0, 0, 0);
	}
	ak = k;
	amsk = (1 << n) - 1;
	ans -= d[ak][amsk]; //now it is real ans;
}

void readdata() {
	assert(scanf("%d%d%d", &n, &m, &k) == 3);
	assert(1 <= n && n <= 14);
	assert(1 <= m && m <= (n * (n - 1)) / 2);
	assert(1 <= k && k <= n);
	memset(g, 0, sizeof g);
	ans = 0;
	forn(i, m) {
		int x, y, z;
		assert(scanf("%d%d%d", &x, &y, &z) == 3);
		assert(1 <= x && x <= n);
		assert(1 <= y && y <= n);
		assert(x != y);
		assert(1 <= z && z <= 10000000);
		ans += z;
		--x;
		--y;
		assert(g[x][y] == 0 && g[y][x] == 0);
		g[x][y] = g[y][x] = z;
	}
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

